#ifndef ___CONFIG_MGR_H___
#define ___CONFIG_MGR_H___

#include <windows.h>
#include <stdlib.h>
#include <stdio.h>

#include <windows.h>

#if (defined(_WINDOWS_H) || defined(_WINDOWS_))
#define CHAR_SEPARATOR '\\'
#else
#define CHAR_SEPARATOR '/'
#endif

#define NAME_CONFIGFILE "HashCalc.cfg"

#define CONFIG_CONTAINER_SIZE 10

#define ALG_SHA1  0
#define ALG_MD5   1
#define ALG_MD2   2
#define ALG_CRC32 3
#define ALG_MD4   4
#define ALG_GHASH 5
#define ALG_GOST  6

// An 64-bit unsigned integer
#ifndef UINT64
typedef unsigned __int64 UINT64;
#endif

class CConfigMgr
{
public:
	CConfigMgr();
	virtual ~CConfigMgr();

	void SetOption(int nIndex, BOOL bState);
	BOOL GetOption(int nIndex);

	void Save();

private:
	void Init();
	void LoadCurrentProfile();
	
	void GetPathOfFile(char *szPath, char *szFile);
	void GetConfigFile(char *szCfgFile);

	char m_szFile[MAX_PATH];
	unsigned char m_data[CONFIG_CONTAINER_SIZE];
};

#endif // ___CONFIG_MGR_H___
