#include "stdafx.h"
#include "HashCalc.h"
#include "HashCalcDlg.h"

#include "HyperLink.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

	HCURSOR cursorLink;

	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CHyperLink	m_hlMail;
	CButtonST	m_btLicense;
	CButtonST	m_btClose;
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnLicense();
	afx_msg void OnDestroy();
	afx_msg void OnClose();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_EMAIL, m_hlMail);
	DDX_Control(pDX, IDC_LICENSE, m_btLicense);
	DDX_Control(pDX, IDOK, m_btClose);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_BN_CLICKED(IDC_LICENSE, OnLicense)
	ON_WM_DESTROY()
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////

CHashCalcDlg::CHashCalcDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHashCalcDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CHashCalcDlg)
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CHashCalcDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHashCalcDlg)
	DDX_Control(pDX, IDC_CHOICESLIST, m_listChoices);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CHashCalcDlg, CDialog)
	//{{AFX_MSG_MAP(CHashCalcDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_MEASUREITEM()
	ON_WM_MENUCHAR()
	ON_WM_INITMENUPOPUP()
	ON_COMMAND(ID_FILE_EXIT, OnFileExit)
	ON_COMMAND(ID_HASH_FILES, OnHashFiles)
	ON_COMMAND(ID_HASH_TEXTS, OnHashTexts)
	ON_COMMAND(ID_HASH_OPTIONS, OnHashOptions)
	ON_NOTIFY(NM_CLICK, IDC_CHOICESLIST, OnClickChoicesList)
	ON_WM_CLOSE()
	ON_COMMAND(ID_ABOUT, OnAbout)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////

BOOL CHashCalcDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if(pSysMenu != NULL)
	{
		/* CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		} */

		pSysMenu->EnableMenuItem(SC_SIZE, MF_BYCOMMAND | MF_GRAYED);
		pSysMenu->EnableMenuItem(SC_MAXIMIZE, MF_BYCOMMAND | MF_GRAYED);
	}

	SetIcon(m_hIcon, TRUE);
	SetIcon(m_hIcon, FALSE);

	// Setup the new XP-style BCMenu
	m_menu.SetIconSize(16, 16);
	m_menu.SetMenuDrawMode(BCMENU_DRAWMODE_XP); // <<<!=>>> BCMENU_DRAWMODE_ORIGINAL
	m_menu.SetSelectDisableMode(FALSE);
	m_menu.SetXPBitmap3D(FALSE);
	m_menu.SetBitmapBackground(RGB(255,0,255));
	m_menu.LoadMenu(IDR_MAINMENU);
	m_menu.LoadToolbar(IDR_MENUICONS);
	m_bMenu = SetMenu(&m_menu);
	ASSERT(m_bMenu == TRUE);

	// Create the pages
	m_bPageHashFiles = m_pageHashFiles.Create(IDD_HASH_FILES, this);
	m_bPageHashTexts = m_pageHashTexts.Create(IDD_HASH_TEXTS, this);
	m_bPageHashOptions = m_pageHashOptions.Create(IDD_HASH_OPTIONS, this);
	ASSERT(m_bPageHashFiles == TRUE);
	ASSERT(m_bPageHashTexts == TRUE);
	ASSERT(m_bPageHashOptions == TRUE);

	// Adjust the menu separator line (fix dialog editor bug)
	CRect rectMenuSep;
	GetDlgItem(IDC_MENU_SEPARATOR)->GetWindowRect(rectMenuSep);
	ScreenToClient(rectMenuSep);
	rectMenuSep.right += 3;
	GetDlgItem(IDC_MENU_SEPARATOR)->MoveWindow(rectMenuSep);

	SetupOutlookBar();

	// Get the page area
	CRect rcDlgs;
	GetDlgItem(IDC_PAGES_AREA)->GetWindowRect(rcDlgs);
	ScreenToClient(rcDlgs);

	// Move pages to the page area
	m_pageHashFiles.MoveWindow(rcDlgs);
	m_pageHashTexts.MoveWindow(rcDlgs);
	m_pageHashOptions.MoveWindow(rcDlgs);

	// Activate a page
	ActivatePage(PAGE_HASH_FILES);

	return FALSE; // FALSE = control gets focus
}

void CHashCalcDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CHashCalcDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this);

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CHashCalcDlg::OnQueryDragIcon()
{
	return (HCURSOR)m_hIcon;
}

void CHashCalcDlg::OnFileExit() 
{
	PrepareExit();
	OnOK();
}

void CHashCalcDlg::OnHashFiles() 
{
	ActivatePage(PAGE_HASH_FILES);
}

void CHashCalcDlg::OnHashTexts() 
{
	ActivatePage(PAGE_HASH_TEXTS);
}

void CHashCalcDlg::OnHashOptions() 
{
	ActivatePage(PAGE_HASH_OPTIONS);
}

void CHashCalcDlg::ProcessClick(int nItem)
{
	if(nItem == 0) ActivatePage(PAGE_HASH_FILES);
	if(nItem == 1) ActivatePage(PAGE_HASH_TEXTS);
	if(nItem == 2) ActivatePage(PAGE_HASH_OPTIONS);
}

void CHashCalcDlg::OnClickChoicesList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CPoint pointM;
	GetCursorPos(&pointM);

	COutlookCtrl* lv;
	lv = &m_listChoices;
	lv->ScreenToClient(&pointM);

	UINT nFlags = 0;
	int nHitItem = m_listChoices.HitTest(pointM, &nFlags);

	// If mouse is on an item, process the click
	if(nFlags & LVHT_ONITEM)
	{
		ProcessClick(nHitItem);
	}

	*pResult = 0;
}

void CHashCalcDlg::SetupOutlookBar()
{
	// Create and set image list
	m_ilMenu.Create(IDR_MAINICONS, 32, 1, RGB(255,0,255)); // Purple is transparent
	m_listChoices.SetImageList(&m_ilMenu, LVSIL_NORMAL);

	// Insert items
	m_listChoices.DeleteAllItems();
	m_listChoices.InsertItem(LVIF_TEXT|LVIF_IMAGE,m_listChoices.GetItemCount(),"Hash Files",0,0,1,NULL);
	m_listChoices.InsertItem(LVIF_TEXT|LVIF_IMAGE,m_listChoices.GetItemCount(),"Hash Texts",0,0,2,NULL);
	m_listChoices.InsertItem(LVIF_TEXT|LVIF_IMAGE,m_listChoices.GetItemCount(),"Options",0,0,3,NULL);

	m_listChoices.PostMessage(LVM_SETEXTENDEDLISTVIEWSTYLE, 0, LVS_EX_SI_MENU);
}

void CHashCalcDlg::OnMeasureItem(int nIDCtl, LPMEASUREITEMSTRUCT lpMeasureItemStruct) 
{
	BOOL setflag = FALSE;

	if(lpMeasureItemStruct->CtlType==ODT_MENU)
	{
		if(IsMenu((HMENU)lpMeasureItemStruct->itemID)&&BCMenu::IsMenu((HMENU)lpMeasureItemStruct->itemID))
		{
			m_menu.MeasureItem(lpMeasureItemStruct);
			setflag = TRUE;
		}
	}

	if(!setflag)CDialog::OnMeasureItem(nIDCtl, lpMeasureItemStruct);
}

LRESULT CHashCalcDlg::OnMenuChar(UINT nChar, UINT nFlags, CMenu* pMenu) 
{
	LRESULT lresult = 0;
	
	if(BCMenu::IsMenu(pMenu))
		lresult = BCMenu::FindKeyboardShortcut(nChar, nFlags, pMenu);
	else
		lresult = CDialog::OnMenuChar(nChar, nFlags, pMenu);

	return(lresult);
}

void CHashCalcDlg::OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu) 
{
	CDialog::OnInitMenuPopup(pPopupMenu, nIndex, bSysMenu);

	OnUpdateFlush(pPopupMenu);
	
	if(!bSysMenu)
	{
		if(BCMenu::IsMenu(pPopupMenu)) BCMenu::UpdateMenu(pPopupMenu);
	}
	
}

// BCMenu function
void CHashCalcDlg::OnUpdateFlush(CMenu *pMenu)
{
	ASSERT(pMenu != NULL);
	// check the enabled state of various menu items

	CCmdUI state;
	state.m_pMenu = pMenu;
	ASSERT(state.m_pOther == NULL);
	ASSERT(state.m_pParentMenu == NULL);

	// determine if menu is popup in top-level menu and set m_pOther to
	//  it if so (m_pParentMenu == NULL indicates that it is secondary popup)
	HMENU hParentMenu;
	if (AfxGetThreadState()->m_hTrackingMenu == pMenu->m_hMenu)
		state.m_pParentMenu = pMenu;    // parent == child for tracking popup
	else if ((hParentMenu = ::GetMenu(m_hWnd)) != NULL)
	{
		CWnd* pParent = GetTopLevelParent();
		// child windows don't have menus -- need to go to the top!
		if (pParent != NULL &&
			(hParentMenu = ::GetMenu(pParent->m_hWnd)) != NULL)
		{
			int nIndexMax = ::GetMenuItemCount(hParentMenu);
			for (int nIndex = 0; nIndex < nIndexMax; nIndex++)
			{
				if (::GetSubMenu(hParentMenu, nIndex) == pMenu->m_hMenu)
				{
					// when popup is found, m_pParentMenu is containing menu
					state.m_pParentMenu = CMenu::FromHandle(hParentMenu);
					break;
				}
			}
		}
	}

	state.m_nIndexMax = pMenu->GetMenuItemCount();
	for (state.m_nIndex = 0; state.m_nIndex < state.m_nIndexMax;
		state.m_nIndex++)
	{
		state.m_nID = pMenu->GetMenuItemID(state.m_nIndex);
		if (state.m_nID == 0)
			continue; // menu separator or invalid cmd - ignore it

		ASSERT(state.m_pOther == NULL);
		ASSERT(state.m_pMenu != NULL);
		if (state.m_nID == (UINT)-1)
		{
			// possibly a popup menu, route to first item of that popup
			state.m_pSubMenu = pMenu->GetSubMenu(state.m_nIndex);
			if (state.m_pSubMenu == NULL ||
				(state.m_nID = state.m_pSubMenu->GetMenuItemID(0)) == 0 ||
				state.m_nID == (UINT)-1)
			{
				continue;       // first item of popup can't be routed to
			}
			state.DoUpdate(this, FALSE);    // popups are never auto disabled
		}
		else
		{
			// normal menu item
			// Auto enable/disable if frame window has 'm_bAutoMenuEnable'
			//    set and command is _not_ a system command.
			state.m_pSubMenu = NULL;
			state.DoUpdate(this, state.m_nID < 0xF000);
		}

		// adjust for menu deletions and additions
		UINT nCount = pMenu->GetMenuItemCount();
		if (nCount < state.m_nIndexMax)
		{
			state.m_nIndex -= (state.m_nIndexMax - nCount);
			while (state.m_nIndex < nCount &&
				pMenu->GetMenuItemID(state.m_nIndex) == state.m_nID)
			{
				state.m_nIndex++;
			}
		}
		state.m_nIndexMax = nCount;
	}
}

void CHashCalcDlg::OnClose() 
{
	PrepareExit();
	CDialog::OnClose();
}

void CHashCalcDlg::PrepareExit()
{
	if(m_bPageHashFiles == TRUE)
	{
		m_pageHashFiles.DestroyWindow();
		m_bPageHashFiles = FALSE;
	}

	if(m_bPageHashTexts == TRUE)
	{
		m_pageHashTexts.DestroyWindow();
		m_bPageHashTexts = FALSE;
	}

	if(m_bPageHashOptions == TRUE)
	{
		m_pageHashOptions.DestroyWindow();
		m_bPageHashOptions = FALSE;
	}

	if(m_bMenu == TRUE)
	{
		m_menu.DestroyMenu();
		m_bMenu = FALSE;
	}
}

void CHashCalcDlg::ActivatePage(int nPage)
{
	switch(nPage)
	{
		case PAGE_HASH_FILES:
			m_pageHashTexts.ShowWindow(SW_HIDE);
			m_pageHashOptions.ShowWindow(SW_HIDE);

			m_pageHashFiles.ShowWindow(SW_SHOW);
			break;

		case PAGE_HASH_TEXTS:
			m_pageHashFiles.ShowWindow(SW_HIDE);
			m_pageHashOptions.ShowWindow(SW_HIDE);

			m_pageHashTexts.ShowWindow(SW_SHOW);
			break;

		case PAGE_HASH_OPTIONS:
			m_pageHashFiles.ShowWindow(SW_HIDE);
			m_pageHashTexts.ShowWindow(SW_HIDE);

			m_pageHashOptions.ShowWindow(SW_SHOW);
			break;

		default:
			break;
	}
}

void CHashCalcDlg::OnAbout() 
{
	// Show the about box
	CAboutDlg dlg;
	dlg.DoModal();
}

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// Setup the hyperlink
	cursorLink = LoadCursor(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDC_HAND));
	m_hlMail.SetURL("mailto:dominik.reichl@t-online.de");
	m_hlMail.SetColours(RGB(0,0,255), RGB(0,0,255), RGB(255,0,0));
	m_hlMail.SetVisited(FALSE);
	m_hlMail.SetLinkCursor(cursorLink);
	m_hlMail.SetUnderline(CHyperLink::ulAlways);
	m_hlMail.SetAutoSize(TRUE);

	// Setup the buttons
	CButtonST *pbt = NULL;
	short i_loop = 0;
	for(i_loop = 0; i_loop < 2; i_loop++)
	{
		// Select button
		if(i_loop == 0) pbt = &m_btLicense;
		if(i_loop == 1) pbt = &m_btClose;

		// Set button properties
		pbt->SetAlign(CButtonST::ST_ALIGN_HORIZ);
		pbt->SetBtnCursor(IDC_HAND);
		pbt->SetColor(CButtonST::BTNST_COLOR_BK_IN, CR_BACK + RGB(16,16,16));
		pbt->SetColor(CButtonST::BTNST_COLOR_BK_OUT, CR_BACK);
		pbt->SetColor(CButtonST::BTNST_COLOR_BK_FOCUS, CR_BACK);
		pbt->SetColor(CButtonST::BTNST_COLOR_FG_IN, RGB(0,0,255));
		pbt->SetColor(CButtonST::BTNST_COLOR_FG_OUT, RGB(0,0,0));
		pbt->SetColor(CButtonST::BTNST_COLOR_FG_FOCUS, RGB(0,0,0));

		// pbt->SetFlat(FALSE);
	}

	// Adjust the button specific information
	m_btLicense.SetTooltipText(_T("Shows the license for this application."));
	m_btLicense.SetBitmaps(IDB_LICENSE, RGB(255, 0, 255));
	m_btClose.SetTooltipText(_T("Close this window."));
	m_btClose.SetBitmaps(IDB_EXIT, RGB(255, 0, 255));

	return TRUE; // return TRUE unless you set the focus to a control
}

void CAboutDlg::OnLicense() 
{
	// Open License.txt with users favorite editor
	ShellExecute(NULL, _T("open"), "GnuGPL2.txt", NULL, NULL, SW_SHOW);
}

void CAboutDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	if(cursorLink != NULL) { DestroyCursor(cursorLink); cursorLink = NULL; }
}

void CAboutDlg::OnClose() 
{
	CDialog::OnClose();
	if(cursorLink != NULL) { DestroyCursor(cursorLink); cursorLink = NULL; }
}
