// HashCalcDlg.h : Header-Datei
//

#if !defined(AFX_HASHCALCDLG_H__34F06403_BF1B_11D6_BF16_0050BF14F5CC__INCLUDED_)
#define AFX_HASHCALCDLG_H__34F06403_BF1B_11D6_BF16_0050BF14F5CC__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "HashFiles.h"
#include "HashTexts.h"
#include "HashOptions.h"

#include "BCMenu.h" // New XP-style menu support
#include "OutlookCtrl.h" // New Outlook-like list control

#define PAGE_HASH_FILES   1
#define PAGE_HASH_TEXTS   2
#define PAGE_HASH_OPTIONS 3

/////////////////////////////////////////////////////////////////////////////
// CHashCalcDlg Dialogfeld

class CHashCalcDlg : public CDialog
{
// Konstruktion
public:
	CHashCalcDlg(CWnd* pParent = NULL);	// Standard-Konstruktor

	void SetupOutlookBar();

	void OnUpdateFlush(CMenu *pMenu); // BCMenu function

	void ActivatePage(int nPage);
	void PrepareExit();
	void ProcessClick(int nItem);

	BCMenu m_menu; // Our XP-style menu
	BOOL m_bMenu; // Menu created?

	CHashFiles m_pageHashFiles;
	CHashTexts m_pageHashTexts;
	CHashOptions m_pageHashOptions;

	BOOL m_bPageHashFiles;
	BOOL m_bPageHashTexts;
	BOOL m_bPageHashOptions;

// Dialogfelddaten
	//{{AFX_DATA(CHashCalcDlg)
	enum { IDD = IDD_HASHCALC_DIALOG };
	COutlookCtrl	m_listChoices;
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CHashCalcDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	HICON m_hIcon;

	CBrush m_brush;
	CImageList m_ilMenu;

	// Generierte Message-Map-Funktionen
	//{{AFX_MSG(CHashCalcDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnMeasureItem(int nIDCtl, LPMEASUREITEMSTRUCT lpMeasureItemStruct);
	afx_msg LRESULT OnMenuChar(UINT nChar, UINT nFlags, CMenu* pMenu);
	afx_msg void OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu);
	afx_msg void OnFileExit();
	afx_msg void OnHashFiles();
	afx_msg void OnHashTexts();
	afx_msg void OnHashOptions();
	afx_msg void OnClickChoicesList(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnClose();
	afx_msg void OnAbout();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio fgt zustzliche Deklarationen unmittelbar vor der vorhergehenden Zeile ein.

#endif // !defined(AFX_HASHCALCDLG_H__34F06403_BF1B_11D6_BF16_0050BF14F5CC__INCLUDED_)
