// HashFiles.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "HashCalc.h"
#include "HashFiles.h"

#include "ConfigMgr.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CHashFiles 


CHashFiles::CHashFiles(CWnd* pParent /*=NULL*/)
	: CDialog(CHashFiles::IDD, pParent)
{
	//{{AFX_DATA_INIT(CHashFiles)
		// HINWEIS: Der Klassen-Assistent fgt hier Elementinitialisierung ein
	//}}AFX_DATA_INIT
}


void CHashFiles::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHashFiles)
	DDX_Control(pDX, IDC_CLEAR_FILELIST, m_btClear);
	DDX_Control(pDX, IDC_COPY_TO_CLIPBOARD, m_btCopy);
	DDX_Control(pDX, IDC_HASH_GO, m_btHash);
	DDX_Control(pDX, IDC_FILESTOHASH, m_listFiles);
	DDX_Control(pDX, IDC_RESULTSWINDOW, m_infoWnd);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CHashFiles, CDialog)
	//{{AFX_MSG_MAP(CHashFiles)
	ON_WM_DROPFILES()
	ON_BN_CLICKED(IDC_CLEAR_FILELIST, OnClearFileList)
	ON_BN_CLICKED(IDC_HASH_GO, OnHashGo)
	ON_BN_CLICKED(IDC_COPY_TO_CLIPBOARD, OnCopyToClipboard)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CHashFiles 

BOOL CHashFiles::OnInitDialog() 
{
	CDialog::OnInitDialog();

	CClientDC dc(this);
	CSize sizeW = dc.GetTextExtent("W",1);

	CRect rect;
	GetDlgItem(IDC_FILESTOHASH)->GetWindowRect(rect);
	UINT sizeCol = rect.Width() - 4 - 16;

	m_listFiles.InsertColumn(0,"Files to hash",LVCFMT_LEFT,sizeCol,0);

	m_infoWnd.SetBackgroundColor (FALSE, RGB (255, 255, 255));

	m_richPara.dwMask = PFM_ALIGNMENT | PFM_NUMBERING | PFM_TABSTOPS;
	m_richPara.wNumbering = 0;
	m_richPara.wAlignment = PFA_LEFT;
	m_richPara.cTabCount = 2;
	m_richPara.rgxTabs[0] = 0;
	m_richPara.rgxTabs[1] = 256;
	m_richPara.cbSize = sizeof (PARAFORMAT);
	m_infoWnd.SetParaFormat (m_richPara);

	m_richFormat.cbSize = sizeof (CHARFORMAT);
	m_richFormat.dwMask = CFM_BOLD | CFM_COLOR | CFM_FACE | CFM_ITALIC | CFM_UNDERLINE | CFM_SIZE;
	m_richFormat.dwEffects = 0;
	m_richFormat.crTextColor = RGB (0, 0, 0);
	m_richFormat.bCharSet = ANSI_CHARSET;
	m_richFormat.bPitchAndFamily = /* DEFAULT_PITCH | */ FF_SWISS;
	m_richFormat.yHeight = 8 * 20; // Points to twips
	sprintf (m_richFormat.szFaceName, "Courier");
	m_infoWnd.SetDefaultCharFormat (m_richFormat);

	m_infoWnd.SetWindowText("Drag and drop the files to hash into the listbox above\r\nand click the 'Hash' button.");

	DragAcceptFiles(TRUE);

	CButtonST *pbt = NULL;
	short i_loop = 0;
	for(i_loop = 0; i_loop < 3; i_loop++)
	{
		// Select button
		if(i_loop == 0) pbt = &m_btHash;
		if(i_loop == 1) pbt = &m_btCopy;
		if(i_loop == 2) pbt = &m_btClear;

		// Set button properties
		pbt->SetAlign(CButtonST::ST_ALIGN_HORIZ);
		pbt->SetBtnCursor(IDC_HAND);
		pbt->SetColor(CButtonST::BTNST_COLOR_BK_IN, CR_BACK + RGB(16,16,16));
		pbt->SetColor(CButtonST::BTNST_COLOR_BK_OUT, CR_BACK);
		pbt->SetColor(CButtonST::BTNST_COLOR_BK_FOCUS, CR_BACK);
		pbt->SetColor(CButtonST::BTNST_COLOR_FG_IN, RGB(0,0,255));
		pbt->SetColor(CButtonST::BTNST_COLOR_FG_OUT, RGB(0,0,0));
		pbt->SetColor(CButtonST::BTNST_COLOR_FG_FOCUS, RGB(0,0,0));
	}

	m_btHash.SetTooltipText(_T("Hash the files in the filebox above and display the results in the window below."));
	m_btHash.SetBitmaps(IDB_HASH, RGB(255, 0, 255));
	m_btClear.SetTooltipText(_T("Clear the filebox."));
	m_btClear.SetBitmaps(IDB_CLEAR, RGB(255, 0, 255));
	m_btCopy.SetTooltipText(_T("Copy the contents of the results box below to the clipboard."));
	m_btCopy.SetBitmaps(IDB_COPY, RGB(255, 0, 255));

	return TRUE; // return TRUE unless you set the focus to a control
}

void CHashFiles::OnDropFiles(HDROP hDropInfo)
{
	char szFilename[MAX_PATH];
	DragAcceptFiles(FALSE);

	UINT ncFiles = DragQueryFile(hDropInfo,-1,NULL,0);
	UINT i = 0;

	for(i = 0; i < ncFiles; i++)
	{
		DragQueryFile(hDropInfo,i,(LPSTR)szFilename,128);
		m_listFiles.InsertItem(LVIF_TEXT,m_listFiles.GetItemCount(),szFilename,0,0,0,NULL);
	}

	DragFinish(hDropInfo);
	DragAcceptFiles(TRUE);
}

void CHashFiles::OnClearFileList() 
{
	m_listFiles.DeleteAllItems();
}

void CHashFiles::OnHashGo() 
{
	unsigned long i = 0, j = 0;
	unsigned long rd = 0;
	char szFile[MAX_PATH];
	char strHash[256];
	unsigned char pBuf[MAX_FILE_BUFFER];
	unsigned char hashBuf[32];
	CString strFinal;
	FILE *fp = NULL;
	CConfigMgr cfg;

	strFinal.Empty();

	CString strInfo;
	strInfo = "Hashing... Please wait...";
	m_infoWnd.SetWindowText(strInfo);

	CSHA1 sha1;
	MD5_CTX md5;
	unsigned long uCrc32 = 0;
	CMD2 md2;
	MD4_CTX md4;
	CGHash ghash;
	GostHashCtx gost;

	UpdateData(TRUE);

	if(cfg.GetOption(ALG_GOST) == TRUE) gosthash_init();

	for(i = 0; i < (unsigned long)m_listFiles.GetItemCount(); i++)
	{
		m_listFiles.GetItemText(i, 0, szFile, MAX_PATH);

		if(cfg.GetOption(ALG_SHA1) == TRUE) sha1.Reset();
		if(cfg.GetOption(ALG_MD5) == TRUE) MD5Init(&md5, 0);
		if(cfg.GetOption(ALG_CRC32) == TRUE) crc32Init(&uCrc32);
		if(cfg.GetOption(ALG_MD2) == TRUE) md2.Init();
		if(cfg.GetOption(ALG_MD4) == TRUE) MD4Init(&md4);
		if(cfg.GetOption(ALG_GHASH) == TRUE) ghash.Init();
		if(cfg.GetOption(ALG_GOST) == TRUE) gosthash_reset(&gost);

		fp = fopen(szFile, "rb"); // Read in BINARY mode !
		if(fp == NULL) continue;

		while(1)
		{
			rd = fread(pBuf, 1, MAX_FILE_BUFFER, fp);
			if(rd != MAX_FILE_BUFFER) break;

			if(cfg.GetOption(ALG_SHA1) == TRUE) sha1.Update(pBuf, MAX_FILE_BUFFER);
			if(cfg.GetOption(ALG_MD5) == TRUE) MD5Update(&md5, pBuf, MAX_FILE_BUFFER);
			if(cfg.GetOption(ALG_CRC32) == TRUE) crc32Update(&uCrc32, pBuf, MAX_FILE_BUFFER);
			if(cfg.GetOption(ALG_MD2) == TRUE) md2.Update(pBuf, MAX_FILE_BUFFER);
			if(cfg.GetOption(ALG_MD4) == TRUE) MD4Update(&md4, pBuf, MAX_FILE_BUFFER);
			if(cfg.GetOption(ALG_GHASH) == TRUE) ghash.Update(pBuf, MAX_FILE_BUFFER);
			if(cfg.GetOption(ALG_GOST) == TRUE) gosthash_update(&gost, pBuf, MAX_FILE_BUFFER);
		}

		if(rd != 0)
		{
			if(cfg.GetOption(ALG_SHA1) == TRUE) sha1.Update(pBuf, rd);
			if(cfg.GetOption(ALG_MD5) == TRUE) MD5Update(&md5, pBuf, rd);
			if(cfg.GetOption(ALG_CRC32) == TRUE) crc32Update(&uCrc32, pBuf, rd);
			if(cfg.GetOption(ALG_MD2) == TRUE) md2.Update(pBuf, rd);
			if(cfg.GetOption(ALG_MD4) == TRUE) MD4Update(&md4, pBuf, rd);
			if(cfg.GetOption(ALG_GHASH) == TRUE) ghash.Update(pBuf, rd);
			if(cfg.GetOption(ALG_GOST) == TRUE) gosthash_update(&gost, pBuf, rd);
		}

		strFinal += szFile;
		strFinal += "\r\n";

		if(cfg.GetOption(ALG_SHA1) == TRUE)
		{
			sha1.Final();
			strHash[0] = 0;
			sha1.ReportHash(strHash, CSHA1::REPORT_HEX);
			strFinal += "SHA-1      : ";
			strFinal += strHash;
			strFinal += "\r\n";
		}

		if(cfg.GetOption(ALG_MD5) == TRUE)
		{
			strHash[0] = 0;
			MD5Final(&md5);
			sprintf(strHash, "%02X", md5.digest[0]);
			for(j = 1; j < 16; j++)
			{
				if(j % 4 != 0) sprintf(strHash, "%s%02X", strHash, md5.digest[j]);
				else sprintf(strHash, "%s %02X", strHash, md5.digest[j]);
			}
			strFinal += "MD5        : ";
			strFinal += strHash;
			strFinal += "\r\n";
		}

		if(cfg.GetOption(ALG_MD4) == TRUE)
		{
			strHash[0] = 0;
			memset(hashBuf, 0, 16);
			MD4Final(hashBuf, &md4);
			sprintf(strHash, "%02X", hashBuf[0]);
			for(j = 1; j < 16; j++)
			{
				if(j % 4 != 0) sprintf(strHash, "%s%02X", strHash, hashBuf[j]);
				else sprintf(strHash, "%s %02X", strHash, hashBuf[j]);
			}
			strFinal += "MD4        : ";
			strFinal += strHash;
			strFinal += "\r\n";
		}

		if(cfg.GetOption(ALG_MD2) == TRUE)
		{
			strHash[0] = 0;
			md2.TruncatedFinal(hashBuf, 16);
			sprintf(strHash, "%02X", hashBuf[0]);
			for(j = 1; j < 16; j++)
			{
				if(j % 4 != 0) sprintf(strHash, "%s%02X", strHash, hashBuf[j]);
				else sprintf(strHash, "%s %02X", strHash, hashBuf[j]);
			}
			strFinal += "MD2        : ";
			strFinal += strHash;
			strFinal += "\r\n";
		}

		if(cfg.GetOption(ALG_GOST) == TRUE)
		{
			strHash[0] = 0;
			memset(hashBuf, 0, 32);
			gosthash_final(&gost, hashBuf);
			sprintf(strHash, "%02X", hashBuf[0]);
			for(j = 1; j < 16; j++)
			{
				if(j % 4 != 0) sprintf(strHash, "%s%02X", strHash, hashBuf[j]);
				else sprintf(strHash, "%s %02X", strHash, hashBuf[j]);
			}
			strFinal += "GOST-Hash  : ";
			strFinal += strHash;
			strHash[0] = 0;
			strFinal += "\r\n            ";
			for(j = 16; j < 32; j++)
			{
				if(j % 4 != 0) sprintf(strHash, "%s%02X", strHash, hashBuf[j]);
				else sprintf(strHash, "%s %02X", strHash, hashBuf[j]);
			}
			strFinal += strHash;
			strFinal += "\r\n";
		}

		if(cfg.GetOption(ALG_CRC32) == TRUE)
		{
			strHash[0] = 0;
			crc32Finish(&uCrc32);
			for(j = 0; j < 4; j++)
			{
				sprintf(strHash, "%s%02X", strHash, (uCrc32 >> (24 - (j * 8))) & 0xFF);
			}
			strFinal += "CRC-32     : ";
			strFinal += strHash;
			strFinal += "\r\n";
		}

		if(cfg.GetOption(ALG_GHASH) == TRUE)
		{
			strHash[0] = 0;
			strFinal += "GHash-3    : ";
			ghash.FinalToStr(strHash, 3);
			strFinal += strHash;
			strFinal += "          GHash-5: ";
			strHash[0] = 0;
			ghash.FinalToStr(strHash, 5);
			strFinal += strHash;
			strFinal += "\r\n";
		}

		strFinal += "\r\n"; // New file block
	}

	m_infoWnd.SetWindowText(strFinal);
}

void CHashFiles::OnCopyToClipboard() 
{
	long reFirst = 0, reLast = 0;
	long rnFirst = 0, rnLast = 0;

	m_infoWnd.SetFocus();
	m_infoWnd.GetSel(reFirst, reLast);
	m_infoWnd.SetSel(0,-1);
	m_infoWnd.Copy();
	m_infoWnd.SetSel(reFirst, reLast);
}
