// HashOptions.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "HashCalc.h"
#include "HashOptions.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CHashOptions 


CHashOptions::CHashOptions(CWnd* pParent /*=NULL*/)
	: CDialog(CHashOptions::IDD, pParent)
{
	//{{AFX_DATA_INIT(CHashOptions)
	m_b01 = FALSE;
	m_b02 = FALSE;
	m_b03 = FALSE;
	m_b04 = FALSE;
	m_b05 = FALSE;
	m_b06 = FALSE;
	m_b07 = FALSE;
	//}}AFX_DATA_INIT
}


void CHashOptions::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHashOptions)
	DDX_Control(pDX, IDC_RFC1321, m_rfc1321);
	DDX_Control(pDX, IDC_RFC1320, m_rfc1320);
	DDX_Control(pDX, IDC_RFC1319, m_rfc1319);
	DDX_Check(pDX, IDC_ALG01, m_b01);
	DDX_Check(pDX, IDC_ALG02, m_b02);
	DDX_Check(pDX, IDC_ALG03, m_b03);
	DDX_Check(pDX, IDC_ALG04, m_b04);
	DDX_Check(pDX, IDC_ALG05, m_b05);
	DDX_Check(pDX, IDC_ALG06, m_b06);
	DDX_Check(pDX, IDC_ALG07, m_b07);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CHashOptions, CDialog)
	//{{AFX_MSG_MAP(CHashOptions)
	ON_BN_CLICKED(IDC_ALG01, OnAlg01)
	ON_BN_CLICKED(IDC_ALG02, OnAlg02)
	ON_BN_CLICKED(IDC_ALG03, OnAlg03)
	ON_BN_CLICKED(IDC_ALG04, OnAlg04)
	ON_BN_CLICKED(IDC_ALG05, OnAlg05)
	ON_BN_CLICKED(IDC_ALG06, OnAlg06)
	ON_BN_CLICKED(IDC_ALG07, OnAlg07)
	ON_WM_DESTROY()
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CHashOptions 

BOOL CHashOptions::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CConfigMgr cfg;
	m_b01 = cfg.GetOption(ALG_SHA1);
	m_b02 = cfg.GetOption(ALG_MD5);
	m_b03 = cfg.GetOption(ALG_MD2);
	m_b04 = cfg.GetOption(ALG_CRC32);
	m_b05 = cfg.GetOption(ALG_MD4);
	m_b06 = cfg.GetOption(ALG_GHASH);
	m_b07 = cfg.GetOption(ALG_GOST);

	unsigned long i = 0;
	CHyperLink *pLink;
	cursorLink = ::LoadCursor(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDC_HAND));
	for(i = 0; i < 3; i++)
	{
		if(i == 0) pLink = &m_rfc1319;
		if(i == 1) pLink = &m_rfc1320;
		if(i == 2) pLink = &m_rfc1321;

		pLink->SetColours(RGB(0,0,255), RGB(0,0,255), RGB(255,0,0));
		pLink->SetVisited(FALSE);
		pLink->SetLinkCursor(cursorLink);
		pLink->SetUnderline(CHyperLink::ulAlways);
		pLink->SetAutoSize(TRUE);
	}
	m_rfc1319.SetURL("ftp://ftp.isi.edu/in-notes/rfc1319.txt");
	m_rfc1320.SetURL("ftp://ftp.isi.edu/in-notes/rfc1320.txt");
	m_rfc1321.SetURL("ftp://ftp.isi.edu/in-notes/rfc1321.txt");

	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

void CHashOptions::SaveState()
{
	UpdateData(TRUE);

	CConfigMgr cfg;
	cfg.SetOption(ALG_SHA1, m_b01);
	cfg.SetOption(ALG_MD5, m_b02);
	cfg.SetOption(ALG_MD2, m_b03);
	cfg.SetOption(ALG_CRC32, m_b04);
	cfg.SetOption(ALG_MD4, m_b05);
	cfg.SetOption(ALG_GHASH, m_b06);
	cfg.SetOption(ALG_GOST, m_b07);
	cfg.Save();
}

void CHashOptions::OnDestroy() 
{
	CDialog::OnDestroy();
	if(cursorLink != NULL) { DestroyCursor(cursorLink); cursorLink = NULL; }
}

void CHashOptions::OnClose() 
{
	if(cursorLink != NULL) { DestroyCursor(cursorLink); cursorLink = NULL; }
	CDialog::OnClose();
}

void CHashOptions::OnAlg01() 
{
	SaveState();
}

void CHashOptions::OnAlg02() 
{
	SaveState();
}

void CHashOptions::OnAlg03() 
{
	SaveState();
}

void CHashOptions::OnAlg04() 
{
	SaveState();
}

void CHashOptions::OnAlg05() 
{
	SaveState();
}

void CHashOptions::OnAlg06() 
{
	SaveState();	
}

void CHashOptions::OnAlg07() 
{
	SaveState();
}
